--
-- henly 20 (Ls_uk Modteam)
-- 10.12.2010
--
-- > www.LS-UK.info


manitou = {};

function manitou.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations) and SpecializationUtil.hasSpecialization(Steerable, specializations) ;
end;

function manitou:load(xmlFile)
   
	self.kinkJoint = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.kinkSteering#kinkJoint"), 0);
	self.kinkOrientation = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.kinkSteering#wheelOrientation"));
	self.setAdditionalLights = SpecializationUtil.callSpecializationsFunction("setAdditionalLights");

	local rotationPartNode6 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart6#index"));
    if rotationPartNode6 ~= nil then
        self.rotationPart6 = {};
        self.rotationPart6.node = rotationPartNode6;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart6#minRot"));
        self.rotationPart6.minRot = {};
        self.rotationPart6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart6#maxRot"));
        self.rotationPart6.maxRot = {};
        self.rotationPart6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart6#rotTime"), 2)*1000;
        self.rotationPart6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart6#touchRotLimit"), 10));
    end;

	local rotationPartNode9 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart9#index"));
    if rotationPartNode9 ~= nil then
        self.rotationPart9 = {};
        self.rotationPart9.node = rotationPartNode9;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart9#minRot"));
        self.rotationPart9.minRot = {};
        self.rotationPart9.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart9.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart9.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart9#maxRot"));
        self.rotationPart9.maxRot = {};
        self.rotationPart9.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart9.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart9.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart9.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart9#rotTime"), 2)*1000;
        self.rotationPart9.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart9#touchRotLimit"), 10));
    end;
	local rotationPartNode10 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart10#index"));
    if rotationPartNode10 ~= nil then
        self.rotationPart10 = {};
        self.rotationPart10.node = rotationPartNode10;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart10#minRot"));
        self.rotationPart10.minRot = {};
        self.rotationPart10.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart10.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart10.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart10#maxRot"));
        self.rotationPart10.maxRot = {};
        self.rotationPart10.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart10.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart10.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart10.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart10#rotTime"), 2)*1000;
        self.rotationPart10.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart10#touchRotLimit"), 10));
    end;
	local rotationPartNode11 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart11#index"));
    if rotationPartNode11 ~= nil then
        self.rotationPart11 = {};
        self.rotationPart11.node = rotationPartNode11;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart11#minRot"));
        self.rotationPart11.minRot = {};
        self.rotationPart11.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart11.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart11.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart11#maxRot"));
        self.rotationPart11.maxRot = {};
        self.rotationPart11.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart11.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart11.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart11.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart11#rotTime"), 2)*1000;
        self.rotationPart11.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart11#touchRotLimit"), 10));
    end;
	local rotationPartNode12 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.rotationPart12#index"));
    if rotationPartNode12 ~= nil then
        self.rotationPart12 = {};
        self.rotationPart12.node = rotationPartNode12;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart12#minRot"));
        self.rotationPart12.minRot = {};
        self.rotationPart12.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart12.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart12.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPart12#maxRot"));
        self.rotationPart12.maxRot = {};
        self.rotationPart12.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPart12.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPart12.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPart12.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart12#rotTime"), 2)*1000;
        self.rotationPart12.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPart12#touchRotLimit"), 10));
    end;

    self.hudInfoBasePosX = 0;
    self.hudInfoBaseWidth = 0.1;
    self.hudInfoBasePosY = 0.26;
    self.hudInfoBaseHeight = 0.5;
    self.infoPanelPath = Utils.getFilename("help.png", self.baseDirectory);
	self.hudInfoBaseOverlay = Overlay:new("hudInfoBaseOverlay", self.infoPanelPath, self.hudInfoBasePosX, self.hudInfoBasePosY, self.hudInfoBaseWidth, self.hudInfoBaseHeight);
    self.showHudInfoBase = false;
	
	self.numbrakelights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.brakelights#count"), 0);
    self.brakelights = {};
    for i=1, self.numbrakelights do
        local brakelightnamei = string.format("vehicle.brakelights.brakelight" .. "%d", i);
        self.brakelights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, brakelightnamei .. "#index"));
        setVisibility(self.brakelights[i], false);
    end;

	self.brakelightsActive = false;
    self.braking = false;
	
	self.numReverselights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.reverselights#count"), 0);
    self.reverselights = {};
    for i=1, self.numReverselights do
        local reverselightnamei = string.format("vehicle.reverselights.reverselight" .. "%d", i);
        self.reverselights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, reverselightnamei .. "#index"));
        setVisibility(self.reverselights[i], false);
    end;
	self.reverselightsActive = false;
	
	self.numFrontWorkLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.frontWorkLights#count"), 0);
    self.frontWorkLights = {};
    for i=1, self.numFrontWorkLights do
        local frontWorkLightsNamei = string.format("vehicle.frontWorkLights.frontWorkLight" .. "%d", i);
        self.frontWorkLights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, frontWorkLightsNamei .. "#index"));
        setVisibility(self.frontWorkLights[i], false);
    end;
	
	self.numWorkLights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.workLights#count"), 0);
    self.workLights = {};
    for i=1, self.numWorkLights do
        local workLightsNamei = string.format("vehicle.workLights.workLight" .. "%d", i);
        self.workLights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, workLightsNamei .. "#index"));
        setVisibility(self.workLights[i], false);
    end;
	
	self.workingLights = {};
	self.workingLights[1] = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.workingLights#index1"));
	self.workingLights[2] = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.workingLights#index2"));
	self.workingLights[3] = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.workingLights#index3"));
	
	self.headlightsLightActive = false;
	self.backspotLightActive = false;
	self.frontspotLightActive = false;

	self.switchLights = {};
	self.switchLights[1] = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.switchLights#index1"));
	self.switchLights[2] = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.switchLights#index2"));
	self.switchLights[3] = Utils.indexToObject(self.components,getXMLString(xmlFile,"vehicle.switchLights#index3"));
	
	self.switchSpotLightsActive = false;
	self.switchHeadLightsActive = false;
	self.switchBeaconLightsActive = false;

	self.lightsActiveR = false;
	self.headlightSwitchR = false;
	self.beaconSwitchR = false;
	
	self.boomextSwitch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.boomextSwitch#index"));
	self.boomoutSwitch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.boomoutSwitch#index"));	
	self.lightSwitch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.lightSwitch#index"));
	self.headlightSwitch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.headlightSwitch#index"));
	self.beaconSwitch = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.beaconSwitch#index"));	
	
	self.armrot = {};
	self.armrot.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.armRot#index"));
	self.armrot.minRot = {Utils.degToRad(getXMLFloat(xmlFile, "vehicle.armRot#minRot"))};
	self.armrot.maxRot = {Utils.degToRad(getXMLFloat(xmlFile, "vehicle.armRot#maxRot"))};
	self.armrot.Rot = {Utils.degToRad(getXMLFloat(xmlFile, "vehicle.armRot#Rot"))};
	self.armrot.rotTime = getXMLFloat(xmlFile, "vehicle.armRot#rotTime")*1000;
    self.armrot.posX = true;
    self.armrot.posZ = true;
		
	self.exhaustingSystem = {};	
	self.exhaustingSystem.cap = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.dynamicExhaustingSystem#cap"));
	self.exhaustingSystem.maxRot = Utils.degToRad(Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.dynamicExhaustingSystem#maxRot"),0));
	self.exhaustingSystem.maxRpm = self.motor:getMaxRpm();
	
	local startSequence = AnimCurve:new(linearInterpolator4);
	local i=0;
	while true do
		local path = string.format("vehicle.dynamicExhaustingSystem.startSequence.key(%d)", i);
		local timeStamp = getXMLFloat(xmlFile, path .. "#time");
		if timeStamp == nil then
			break;
		end;
		local r,g,b,alpha = Utils.getVectorFromString(getXMLString(xmlFile, path .. "#value"));
		startSequence:addKeyframe({x=r, y=g, z=b, w=alpha, time=timeStamp})		
		i = i + 1;
	end;
	
	self.exhaustingSystem.minAlpha = math.min(math.abs(Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.dynamicExhaustingSystem#minAlpha"),0)),1);
	self.exhaustingSystem.maxAlpha = math.min(math.abs(Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.dynamicExhaustingSystem#maxAlpha"),1)),1);
	local x1,y1,z1,w1 = startSequence:get(1.0);
	self.exhaustingSystem.startSequence = startSequence;
	self.exhaustingSystem.lastValue = {x=x1,y=y1,z=z1,w=w1};
	self.exhaustingSystem.param = getXMLString(xmlFile, "vehicle.dynamicExhaustingSystem#param");
	self.exhaustingSystem.offset = 0;
	self.exhaustingSystem.deltaTime = 0;

	self.cameraRotNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.cameraRotNode#index"));
	self.seatNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.seatNode#index"));
	self.farmerNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.characterNode#index"));
	
	if self.cameraRotNode ~=nil then
		local x,y,z = getTranslation(self.cameraRotNode);
		self.startXTranslation = x;
		self.startYTranslation = y;
		self.startZTranslation = z;
	end;
	
	if self.seatNode ~=nil then
		local x,y,z = getTranslation(self.seatNode);
		self.startSeatXTranslation = x;
		self.startSeatYTranslation = y;
		self.startSeatZTranslation = z;
	end;

	if self.farmerNode ~=nil then
		local x,y,z = getTranslation(self.farmerNode);
		self.startFarmerXTranslation = x;
		self.startFarmerYTranslation = y;
		self.startFarmerZTranslation = z;
	end;

	SeatSoundFile = Utils.getFilename("sounds/seatSound.wav", self.baseDirectory);
    self.SeatSoundId = createSample("SeatSound");
    loadSample(self.SeatSoundId, SeatSoundFile, false);
    self.SeatPlaying = false;
	self.SeatSoundOffset = getSampleDuration(self.SeatSoundId);
	
	self.averageYTranslation = self.startYTranslation;
	self.camTranslation = self.startYTranslation;
	self.maxTranslationPrCycle = 0.00008;
	self.offsetTranslation = 0;
	self.offsetAdjustmentTranslation = 0;
	
	self.indoorCamera = true;
	self.cameraChanged = false;	
	
	self.frontLightMode = 0;
	self.workLightActive = false;
	self.frontWorkLightActive = false;
	self.switchSpotLightsActive = false;
	self.backspotLightActive = false;
	self.frontspotLightActive = false;
	
	self.rotationMax9Active = false;
end;

function manitou:delete()
	if self.SeatPlaying ~= nil then
		stopSample(self.SeatSoundId);
	end;
	
end;

function manitou:readStream(streamId, connection)
	self:setAdditionalLights(streamReadInt8(streamId), true);
end;

function manitou:writeStream(streamId, connection)
	streamWriteInt8(streamId, self.frontLightMode);	
end;

function manitou:mouseEvent(posX, posY, isDown, isUp, button)
end;

function manitou:keyEvent(unicode, sym, modifier, isDown)
	if self.isMotorStarted then

		if sym == Input.KEY_w then
			self.rotationMax6 = isDown;
		end;
		if sym == Input.KEY_s then
			self.rotationMin6 = isDown;
		end;
	end;
	
	if isDown and sym == Input.KEY_KP_0 then
		self.showHudInfoBase = not self.showHudInfoBase;
	end;

end;

function manitou:update(dt)

      if self:getIsActiveForInput() and self.isClient then
	
		if InputBinding.hasEvent(InputBinding.TOGGLE_BEACON_LIGHTS) then
              if (not self.toggleLightsSound) then
                  self.toggleLightsSound = createSample("toggleLightsSound");
                  loadSample(self.toggleLightsSound, "dataS2/sounds/switchFlashlight.wav", false);
                  setSamplePitch(self.toggleLightsSound, 0.5);
              end;
              playSample(self.toggleLightsSound, 1, 1.0, 0);
			self.switchBeaconLightsActive = not self.switchBeaconLightsActive;
			self.beaconSwitchR = not self.beaconSwitchR;
		end;
		
		if InputBinding.hasEvent(InputBinding.MANSPOTS) then
              if (not self.toggleLightsSound) then
                  self.toggleLightsSound = createSample("toggleLightsSound");
                  loadSample(self.toggleLightsSound, "dataS2/sounds/switchFlashlight.wav", false);
                  setSamplePitch(self.toggleLightsSound, 0.5);
              end;
              playSample(self.toggleLightsSound, 1, 1.0, 0);
				if self.frontLightMode >= 4 then
				self.frontLightMode = 0;
				end;
			self:setAdditionalLights(math.abs(self.frontLightMode + 1));
		end;
		
          if InputBinding.hasEvent(InputBinding.TOGGLE_LIGHTS) then
              if (not self.toggleLightsSound) then
                  self.toggleLightsSound = createSample("toggleLightsSound");
                  loadSample(self.toggleLightsSound, "dataS2/sounds/switchFlashlight.wav", false);
                  setSamplePitch(self.toggleLightsSound, 0.5);
              end;
              playSample(self.toggleLightsSound, 1, 1.0, 0);
              self.lightsActiveR = not self.lightsActiveR;
			self.switchHeadLightsActive = not self.switchHeadLightsActive;
			self.headlightsLightActive = not self.headlightsLightActive;
			self.headlightSwitchR = not self.headlightSwitchR;
		end;

		if self:getIsActiveForInput() and not g_currentMission.fixedCamera then
			if InputBinding.hasEvent(InputBinding.CAMERA_SWITCH) then
				self.indoorCamera = not self.indoorCamera;
			end;
		end;
	end;
	
	if self:getIsActiveForInput() and self.isMotorStarted then
		if InputBinding.isPressed(InputBinding.FRONTLOADER_ARM_POSMAN) then
		    self.armrot.posX = true;
			x,y,z = getRotation(self.armrot.node);	
		    local newRot = Utils.getMovedLimitedValues({x}, self.armrot.maxRot, self.armrot.minRot, 1, self.armrot.rotTime, dt, true);
		    setRotation(self.armrot.node, newRot[1],y,z);	
	    end;
		if InputBinding.isPressed(InputBinding.FRONTLOADER_ARM_NEGMAN) then
		    self.armrot.posX = false;
			x,y,z = getRotation(self.armrot.node);	
		    local newRot = Utils.getMovedLimitedValues({x}, self.armrot.maxRot, self.armrot.minRot, 1, self.armrot.rotTime, dt, false );
		    setRotation(self.armrot.node, newRot[1],y,z);		
		end;
		if not InputBinding.isPressed(InputBinding.FRONTLOADER_ARM_NEGMAN) and not InputBinding.isPressed(InputBinding.FRONTLOADER_ARM_POSMAN) then
		    if self.armrot.posX then
		    	x,y,z = getRotation(self.armrot.node);	
		        local newRot = Utils.getMovedLimitedValues({x}, self.armrot.minRot, self.armrot.Rot, 1, self.armrot.rotTime/2, dt, true);
		        setRotation(self.armrot.node, newRot[1],y,z);
            else
			    x,y,z = getRotation(self.armrot.node);	
		        local newRot = Utils.getMovedLimitedValues({x}, self.armrot.maxRot, self.armrot.Rot, 1, self.armrot.rotTime/2, dt, true);
		        setRotation(self.armrot.node, newRot[1],y,z);		
		    end;
		end;
		if InputBinding.isPressed(InputBinding.FRONTLOADER_TILT_POSMAN) then
		 	self.armrot.posZ = true;   
			x,y,z = getRotation(self.armrot.node);	
		    local newRot = Utils.getMovedLimitedValues({z}, self.armrot.maxRot, self.armrot.minRot, 1, self.armrot.rotTime, dt, true );
		    setRotation(self.armrot.node, x,y,newRot[1]);	
		elseif InputBinding.isPressed(InputBinding.FRONTLOADER_TILT_NEGMAN) then
		    self.armrot.posZ = false;   
			x,y,z = getRotation(self.armrot.node);	
		    local newRot = Utils.getMovedLimitedValues({z}, self.armrot.maxRot, self.armrot.minRot, 1, self.armrot.rotTime, dt, false );
		    setRotation(self.armrot.node, x,y,newRot[1]);	
		end;
		if not InputBinding.isPressed(InputBinding.FRONTLOADER_TILT_NEGMAN) and not InputBinding.isPressed(InputBinding.FRONTLOADER_TILT_POSMAN) then
		    if self.armrot.posZ then
			    x,y,z = getRotation(self.armrot.node);	
		        local newRot = Utils.getMovedLimitedValues({z}, self.armrot.minRot, self.armrot.Rot, 1, self.armrot.rotTime/2, dt, true);
		        setRotation(self.armrot.node, x,y,newRot[1]);		
		    else
			    x,y,z = getRotation(self.armrot.node);	
		        local newRot = Utils.getMovedLimitedValues({z}, self.armrot.maxRot, self.armrot.Rot, 1, self.armrot.rotTime/2, dt, true);
		        setRotation(self.armrot.node, x,y,newRot[1]);		
			end;
		end;
	end;

	if self.headlightSwitchR then
		setRotation(self.headlightSwitch, Utils.degToRad(15),0,0);
	end;
	if not self.headlightSwitchR then
		setRotation(self.headlightSwitch, Utils.degToRad(1),0,0);
	end;
	if self.beaconSwitchR then
		setRotation(self.beaconSwitch, Utils.degToRad(20),0,0);
		else
		setRotation(self.beaconSwitch, Utils.degToRad(0),0,0);
	end;


end;

function manitou:updateTick(dt)

	if self.isMotorStarted then
		if self.kinkJoint ~= 0 then
			setJointFrame(self.componentJoints[self.kinkJoint].jointIndex , 0, self.componentJoints[self.kinkJoint].jointNode);   
			local x, y, z = getRotation(self.kinkOrientation);	    
			setRotation(self.kinkOrientation, 0,y,0);
		end;
	end;
	
	if self:getIsActive() and self.isClient then

		inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);

        if InputBinding.isAxisZero(inputAxisY) then
        inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_MOVE_FORWARD_VEHICLE);
        end;
		
		if self.isEntered ~= nil then
		if self.brakelightsActive then
			for i=1, self.numbrakelights do
				local brakelight = self.brakelights[i];
				setVisibility(brakelight, self.brakelightsActive);
			end;
		else
			for i=1, self.numbrakelights do
				local brakelight = self.brakelights[i];
				setVisibility(brakelight, self.brakelightsActive, false);
			end;
		end;
		if (self.movingDirection*self.lastSpeed*(-inputAxisY)) < -0.001 then		
			self.brakelightsActive = true;
			self.braking = true;
			self.rotationMax9Active = true;
		else
			self.brakelightsActive = false;
			self.braking = false;
			self.rotationMax9Active = false;
		end;
		end; 	
		
		if self.reverselightsActive then
			for i=1, self.numReverselights do
				local reverselight = self.reverselights[i];
				setVisibility(reverselight, self.reverselightsActive);
			end;
		else
			for i=1, self.numReverselights do
				local reverselight = self.reverselights[i];
				setVisibility(reverselight, self.reverselightsActive, false);
			end;
		end;
			if self.movingDirection < 0 then
				self.reverselightsActive = true;
			else
				self.reverselightsActive = false;
			end;
		
		if self.rotationPart6 ~= nil and (self.rotationMax6 or self.rotationMin6) then
			local x, y, z = getRotation(self.rotationPart6.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart6.maxRot, self.rotationPart6.minRot, 3, self.rotationPart6.rotTime, dt, not self.rotationMax6);
			setRotation(self.rotationPart6.node, unpack(newRot));
		end;

		if self.rotationPart9 ~= nil then
			local x, y, z = getRotation(self.rotationPart9.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.rotationPart9.maxRot, self.rotationPart9.minRot, 3, self.rotationPart9.rotTime, dt, not self.rotationMax9Active);
			setRotation(self.rotationPart9.node, unpack(newRot));
		end;
		local maxfootthrottle = 2500;
			if self.rotationPart10 ~= nil then
				local x, y, z = getRotation(self.rotationPart10.node);
				y = ((self.rotationPart10.maxRot[2] - self.rotationPart10.minRot[2]) / maxfootthrottle) * self.motor.lastMotorRpm + self.rotationPart10.minRot[2];
				setRotation(self.rotationPart10.node, x, y ,z);
			end;
		local maxrpmguage = 2700;
			if self.rotationPart11 ~= nil then
				local x, y, z = getRotation(self.rotationPart11.node);
				y = ((self.rotationPart11.maxRot[2] - self.rotationPart11.minRot[2]) / maxrpmguage) * self.motor.lastMotorRpm + self.rotationPart11.minRot[2];
				setRotation(self.rotationPart11.node, x, y ,z);
			end;

		local maxspeedguage = 40;
		local speed = self.lastSpeed*3600;
			if self.rotationPart12 ~= nil then
				local x, y, z = getRotation(self.rotationPart12.node);
				y = ((self.rotationPart12.maxRot[2] - self.rotationPart12.minRot[2]) / maxspeedguage) * speed + self.rotationPart12.minRot[2];
				setRotation(self.rotationPart12.node, x, y ,z);
			end;
		
	if self:getIsActive() then
		if self.exhaustingSystem.cap ~= nil then
			local angle = math.rad(math.random(-20,5)) + self.exhaustingSystem.maxRot * self.motor.lastMotorRpm / self.exhaustingSystem.maxRpm;	
			angle = math.max(math.min(angle, 0), self.exhaustingSystem.maxRot);		
			setRotation(self.exhaustingSystem.cap, 0,0,angle);
		end;
		
		if self.time <= self.playMotorSoundTime then
			local time = (self.exhaustingSystem.deltaTime - (self.playMotorSoundTime - self.time)) / self.exhaustingSystem.deltaTime;
			local x1,y1,z1,w1 = self.exhaustingSystem.startSequence:get(time);
			local values = self.exhaustingSystem.lastValue;
			if math.abs(values.x - x1) > 0.01 or math.abs(values.y - y1) > 0.01 or math.abs(values.z - z1) > 0.01 or math.abs(values.w - w1) > 0.01 then
				setShaderParameter(self.exhaustParticleSystems[1].shape, self.exhaustingSystem.param, x1, y1, z1, w1, false);
				self.exhaustingSystem.lastValue = {x=x1, y=y1, z=z1, w=w1};
			end;
		else
			local alpha = ((self.exhaustingSystem.maxAlpha-self.exhaustingSystem.minAlpha) * self.motor.lastMotorRpm / self.exhaustingSystem.maxRpm)+self.exhaustingSystem.minAlpha;
			if math.abs(self.exhaustingSystem.lastValue.w - alpha) > 0.01 then
				local values = self.exhaustingSystem.lastValue;
				setShaderParameter(self.exhaustParticleSystems[1].shape, self.exhaustingSystem.param, values.x, values.y, values.z, alpha, false);
				self.exhaustingSystem.lastValue.w = alpha;
			end;
		end;
	end;
		
	if self.wheels[1].repr ~= nil and self.wheels[2].repr ~= nil then
		local x,y,z = getTranslation(self.wheels[1].repr);
		local x2,y2,z2 = getTranslation(self.wheels[2].repr);

		self.averageYTranslation = 1.9+(y + y2)/2;
	end;
	
	self.playSeatSound = false;
	if self.camTranslation > self.averageYTranslation then
		self.camTranslation = self.camTranslation - self.maxTranslationPrCycle * dt;
		if self.camTranslation < self.averageYTranslation then
			self.camTranslation = self.averageYTranslation;
		end;
	elseif self.camTranslation < self.averageYTranslation then
		self.camTranslation = self.camTranslation + self.maxTranslationPrCycle * dt;
		if self.camTranslation > self.averageYTranslation then
			self.camTranslation = self.averageYTranslation;
		end;
		if self.camTranslation < self.averageYTranslation - 0.0002 and self.isEntered and self.indoorCamera then
			self.playSeatSound = true;
		end;
	end;
	
	if self.cameraRotNode ~= nil then
		setTranslation(self.cameraRotNode, self.startXTranslation, self.camTranslation+self.offsetAdjustmentTranslation, self.startZTranslation);
	end;
	
	if self.currentWeight ~= nil then
		self.offsetAdjustmentTranslation = -self.currentWeight * 0.000425;
	end;
	
	self.offsetTranslation = self.camTranslation - self.startYTranslation;
	
	local adjustedOffsetTranslation = (self.offsetTranslation)+self.offsetAdjustmentTranslation;
	
	if self.seatNode ~= nil then
		setTranslation(self.seatNode, self.startSeatXTranslation, self.startSeatYTranslation + adjustedOffsetTranslation, self.startSeatZTranslation);
	end;
	
	if self.farmerNode ~= nil then
		setTranslation(self.farmerNode, self.startFarmerXTranslation, self.startFarmerYTranslation+adjustedOffsetTranslation, self.startFarmerZTranslation);
	end;
	
	if self.seatNode ~= nil then
		if self.playSeatSound then
			if not self.SeatPlaying then
				playSample(self.SeatSoundId, 0, 1, 0);
				self.SeatPlaying = true;
			end;
		else
			if self.SeatPlaying then
				stopSample(self.SeatSoundId);
				self.SeatPlaying = false;
			end;
		end;
	end;
	
	setVisibility(self.switchLights[2], self.switchHeadLightsActive);
	setVisibility(self.workingLights[1], self.headlightsLightActive);
	setVisibility(self.switchLights[3], self.switchBeaconLightsActive);	

	end;
end

function manitou:attachImplement(implement)
	
	
end;

function manitou:draw()

	if self.showHudInfoBase then	
		g_currentMission:addExtraPrintText("Key Numpad 0: Menu Off");
	else
		g_currentMission:addExtraPrintText("Key Numpad 0: Menu On");
	end;

	if self.showHudInfoBase and self.isEntered then
		self.hudInfoBaseOverlay:render();
	end;
		

end;

function manitou:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

function manitou:startMotor()
	self.exhaustingSystem.deltaTime = self.playMotorSoundTime - self.time - self.exhaustingSystem.offset;
end;

function manitou:onLeave()
	if self.exhaustingSystem.cap ~= nil then
		setRotation(self.exhaustingSystem.cap, 0,0,0);
	end;
		self.switchHeadLightsActive = false;
		self.switchBeaconLightsActive = false;
		self.headlightsLightActive = false;
		self.workLightActive = false;
		self.frontWorkLightActive = false;
		self.switchSpotLightsActive = false;
		self.backspotLightActive = false;
		self.frontspotLightActive = false;
		self.lightsActiveR = false;
		self.headlightSwitchR = false;
		self.beaconSwitchR = false;
		self.frontLightMode = 0;
	end;

function manitou:setAdditionalLights(additionallights, noEventSend)
	AdditionalLightsEvent.sendEvent(self, additionallights, noEventSend);

	self.frontLightMode = additionallights;
	
	if self.frontLightMode == 0  then
		self.workLightActive = false;
		self.frontWorkLightActive = false;
		self.switchSpotLightsActive = false;
		self.backspotLightActive = false;
		self.frontspotLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, Utils.degToRad(1),0,0);
		end;
	end;
	if self.frontLightMode == 1 then
		self.workLightActive = true;
		self.frontWorkLightActive = false;
		self.switchSpotLightsActive = true;
		self.backspotLightActive = true;
		self.frontspotLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, Utils.degToRad(10),0,0);
		end;
	end;
	if self.frontLightMode == 2 then
		self.workLightActive = true;
		self.frontWorkLightActive = true;
		self.switchSpotLightsActive = true;
		self.backspotLightActive = true;
		self.frontspotLightActive = true;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, Utils.degToRad(20),0,0);
		end;
	end;
	if self.frontLightMode == 3 then
		self.workLightActive = true;
		self.frontWorkLightActive = false;
		self.switchSpotLightsActive = true;
		self.backspotLightActive = true;
		self.frontspotLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, Utils.degToRad(10),0,0);
		end;
	end;
	if self.frontLightMode == 4 then
		self.workLightActive = false;
		self.frontWorkLightActive = false;
		self.switchSpotLightsActive = false;
		self.backspotLightActive = false;
		self.frontspotLightActive = false;
		if self.lightSwitch ~= nil then
			setRotation(self.lightSwitch, Utils.degToRad(1),0,0);
		end;
	end;

	for i=1, self.numFrontWorkLights do
		setVisibility(self.frontWorkLights[i], self.frontWorkLightActive);
	end;
	
	for i=1, self.numWorkLights do
		setVisibility(self.workLights[i], self.workLightActive);
	end;
	
	setVisibility(self.switchLights[1], self.switchSpotLightsActive);
 	setVisibility(self.workingLights[2], self.backspotLightActive);
 	setVisibility(self.workingLights[3], self.frontspotLightActive);
end;

AdditionalLightsEvent = {};
AdditionalLightsEvent_mt = Class(AdditionalLightsEvent, Event);

InitEventClass(AdditionalLightsEvent, "AdditionalLightsEvent");

function AdditionalLightsEvent:emptyNew()
    local self = Event:new(AdditionalLightsEvent_mt);
    self.className="AdditionalLightsEvent";
    return self;
end;

function AdditionalLightsEvent:new(vehicle, additionallights)
    local self = AdditionalLightsEvent:emptyNew()
    self.vehicle = vehicle;
	self.additionallights = additionallights;
    return self;
end;

function AdditionalLightsEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.additionallights = streamReadInt8(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function AdditionalLightsEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));	
	streamWriteInt8(streamId, self.additionallights);	
end;

function AdditionalLightsEvent:run(connection)
	self.vehicle:setAdditionalLights(self.additionallights, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(AdditionalLightsEvent:new(self.vehicle, self.additionallights), nil, connection, self.object);
	end;
end;

function AdditionalLightsEvent.sendEvent(vehicle, additionallights, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(AdditionalLightsEvent:new(vehicle, additionallights), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(AdditionalLightsEvent:new(vehicle, additionallights));
		end;
	end;
end;